(*
  Copyright (c) 2001 by Adam Boduch ( Service for programmers )
  http://programowanie.of.pl
  E - mail: boduch@poland.com
  Build: 12.05.2001 r.
*)

unit Main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls;

type
  TMainForm = class(TForm)
    btnSzyfruj: TButton;
    edtString: TEdit;
    rgWork: TRadioGroup;  // <-- ten komponent jest tutaj dla bajeru
    procedure btnSzyfrujClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  MainForm: TMainForm;

implementation

{$R *.DFM}

var
  Word : String;   // kodowane sowo
  Pass : String;  // haslo

  procedure SaveToFile(Text : String);
  var
    TF : TextFile;
  begin
{ Procedura zapisuje do pliku zakodowany tekst - tekst, ktory pochodzi z parametru
  Text. Nic dodac - nic ujac - odsylam do artykulu "Pliki" na programowanie.of.pl
}
    AssignFile(TF, 'zakodowany tekst.txt');
    Rewrite(TF);
    Write(TF, Text);
    CloseFile(TF);
  end;

  function Szyfruj(sString, Password : String) : String;
  var
    I : Integer;
    PassCount : Integer;
  begin
    PassCount := 0;
    Result := sString; // przypisz wartosc poczatkowa
    for I := 1 to Length(sString) do  // wykonuj dla kazdej litery osobno
    begin
{
   Dla kazdego osobnego znaku zamieniaj na wartosc liczbowa, a nastepnie
   xoruj z kazda litera hasla - powstaje wowczas unikalna kombinacja.
}
      Result[i] := Chr(Ord(sString[i]) xor Ord(Password[PassCount]));
      Inc(PassCount);   // wieksz licznik - kolejne slowo hasla
      if PassCount > Length(Password) then PassCount := 0;  // Jezeli licznik przekroczy dlugosc hasla - wyzeruj
    end;
  end;


procedure TMainForm.btnSzyfrujClick(Sender: TObject);
begin
  Pass := InputBox('Wpisz haso', 'Podaj haso', ''); // przypisz haslo do zmiennej
  if Length(Pass) > 0 then  // Czy w okienku haslo zostalo wpisane? Jezeli tak to...
  begin
    Word := Szyfruj(edtString.Text, Pass); // do zmiennej przypisz rezultad operacji
    MessageDlg('Wyraz wyglda tak: ' + Word, mtInformation, [mbOK], 0);
    edtString.Text := Word;  // wyswietl w komponencie zakodowany String
    SaveToFile(Word); // zapisz do pliku
  end;
end;


end.
